/*
 *  Cylinder.cpp
 *  Assignment3
 *
 *  Created by Zach Gildersleeve on 2/6/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "Cylinder.h"
#include <iostream.h>

Cylinder::Cylinder(Material *mat, const Point &newCenter, double newRadius, double newHeight) :
					Primitive(mat), center(newCenter), radius(newRadius), height(newHeight) {
	
}

bool Cylinder::intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const{

	Vector rayDirection = ray.getDirection();
	Point rayOrigin = ray.getOrigin();
	double a = rayDirection.x * rayDirection.x + rayDirection.z * rayDirection.z;
	double b = 2.0 * (rayDirection.x * (rayOrigin.x - center.x) + rayDirection.z * (rayOrigin.z - center.z));
	double c = (rayOrigin.x - center.x) * (rayOrigin.x - center.x) + (rayOrigin.z - center.z) * (rayOrigin.z - center.z) - radius * radius;

	double desc = b * b - 4 * a * c;
	
	if (desc > 0)
	{
		double root = sqrt(desc);
		double t1 = (-b + root) / (2.0 * a);
		Point p = rayOrigin + rayDirection * t1;
		if((p.y > center.y) && (p.y < center.y + height))
		{
			hit.hit(t1, this, material);
			return true;
		}
		double t2 = (-b - root) / (2.0 * a);
		p = rayOrigin + rayDirection * t2;
		if((p.y > center.y) && (p.y < center.y + height))
		{
			hit.hit(t2, this, material);
			return true;
		}
	}

//	Vector u = cross(ray.direction, direction);
//	u = u / u.length();
//	double distance = fabs(dot(u, (ray.origin, center)));
//	if (distance > radius)
//		return false;
//	std::cout << "hit\n";	
//	
//	double a = ray.direction.x * ray.direction.x + ray.direction.z * ray.direction.z;
//	double b = 2 * (ray.direction.x * ray.origin.x + ray.direction.z * ray.origin.z);
//	double c = (ray.direction.
	
	
	
	
	return false;	
//	double a = dot(ray.direction, ray.direction);
//	double b = 2.0 * (dot(ray.direction, ray.origin) - dot(center, ray.direction));
//	double c = 
	
}

void Cylinder::normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const {
	normal = Vector(hitPoint.x - center.x, 0.0, hitPoint.z - center.z);
	normal.normalize();
	
	
}
