/*
 *  MetalMaterial.h
 *  Assignment5
 *
 *  Created by Zach Gildersleeve on 2/21/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef METALMATERIAL_H
#define METALMATERIAL_H

#include "Material.h"
#include "Color.h"
#include "Point.h"
#include "Ray.h"
#include "HitRecord.h"
#include "Scene.h"

class MetalMaterial : public Material {
	public:
		MetalMaterial(const Color &newColor, int newPhongTerm);
		virtual ~MetalMaterial() {}
		
		virtual void preprocess() {}
		void shade(Color &result, const RenderContext &context,
				   const Ray &ray, const HitRecord &hit, int depth, const Color &attenuation) const;
		
		MetalMaterial(const MetalMaterial &lm);
		MetalMaterial &operator=(const MetalMaterial &lm);
		
	private:
		Color color;
		int phongTerm;
};


#endif