/*
 *  Box.h
 *  Assignment3
 *
 *  Created by Zach Gildersleeve on 2/5/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef BOX_H
#define BOX_H

#include "Primitive.h"
#include "Ray.h"
#include "HitRecord.h"

class Box : public Primitive {
	public:
		Box(Material *newMaterial, const Point newP1, const Point newP2);
		
		virtual ~Box() {}
		
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		virtual void normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const;

		int v[3];

		private:
		
		Point p[2];
		Vector normalVector;
		
	
	
	
};

#endif