/*
 *  GradientBackground.c
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/27/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "GradientBackground.h"

GradientBackground::GradientBackground(Color newColor1, Color newColor2, Vector newUp)
										: color1(newColor1), color2(newColor2), up(newUp) {
	
}

GradientBackground::~GradientBackground() {
	
}

void GradientBackground::preprocess() {
	
}

void GradientBackground::getBackgroundColor(Color &result, const RenderContext &context, const Ray &ray) {
	Vector rayDir = ray.getDirection();
	double s = dot(ray.getDirection(), up) / (rayDir.length() * up.length());
	result = color1 + color2 * ((s + 1.0) * 0.5);
}