/*
 *  Light.h
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/28/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef LIGHT_H
#define LIGHT_H

class Color;
class Vector;
class RenderContext;
class Point;

class Light {
	
	public:
		Light();
		virtual ~Light();
		
		virtual void preprocess();
		virtual double getLight(Color &lightColor, Vector &lightDirection,
							  const RenderContext &context,
							  const Point &location) const = 0;
		
		Light(const Light &l);
		Light &operator=(const Light &l);
	private:
};



#endif