/*
 *  Triangle.h
 *  Assignment3
 *
 *  Created by Zach Gildersleeve on 2/4/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef TRIANGLE_H
#define TRIANGLE_H

#include "Primitive.h"
#include "Point.h"
#include "Ray.h"
#include "HitRecord.h"
//#include <math.h>

class Triangle : public Primitive {
	public:
		Triangle(Material *newMaterial, const Point &newP1, const Point &newP2, const Point &newP3);
		
		~Triangle() {}
	
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		virtual void normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const;
	
	private:
		Point p1;
		Point p2;
		Point p3;
		Vector e1;
		Vector e2;
		Vector normalVector;
	
	
	
	
};

#endif